#if !defined( __MEMCHECK_H )
#define __MEMCHECK_H

#if !defined( __ALLOC_H )
#include <alloc.h>
#endif

typedef void (*mcAppFunc)(void *, void *);

class MemCheck
	{
	public:

		MemCheck();
		~MemCheck();

		int mark();
		int release();
		int getCount();
		void forEach( mcAppFunc, void * );
		int isItem( void * );
		void clear();

	protected:

		int count;
		void **items;
		static struct heapinfo hi;
	};

inline MemCheck::MemCheck() : count(0), items(0)
	{}

inline MemCheck::~MemCheck()
	{
	clear();
	}

inline int MemCheck::getCount()
	{
	return count;
	}

inline void MemCheck::clear()
	{
	delete items;
	items = 0;
	count = 0;
	}

#endif	// __MEMCHECK_H
